cordova.define("cordova-plugin-uctencenttai.UCTencentTaiPlugin", function(require, exports, module) {
               
               var argscheck = require('cordova/argscheck'),
               utils = require('cordova/utils'),
               exec = require('cordova/exec');

               var mediaObjects = {};
    
var UCTencentTaiPlugin = function (successCallback,recorderEndCallback, errorCallback, statusCallback) {
    this.id = utils.createUUID();
    mediaObjects[this.id] = this;
    this.successCallback = successCallback;
    this.recorderEndCallback = recorderEndCallback;
    this.errorCallback = errorCallback;
    this.statusCallback = statusCallback;
     exec(null, this.errorCallback, "UCTencentTaiPlugin", "create", [this.id]);
}

// channel messages
UCTencentTaiPlugin.RECORD_STATE = 1;

UCTencentTaiPlugin.prototype.start = function (text, rank, type, scoreCoeff, refText) {
    exec(this.successCallback, this.errorCallback, "UCTencentTaiPlugin", "start", [text,rank,type,scoreCoeff,refText]);
}

UCTencentTaiPlugin.prototype.stop = function () {
    exec(this.recorderEndCallback, this.errorCallback, "UCTencentTaiPlugin", "stop", null);
}
               
UCTencentTaiPlugin.prototype.cancel = function () {
    exec(null, this.errorCallback, "UCTencentTaiPlugin", "cancel", null);
}


UCTencentTaiPlugin.onStatus = function(id, msgType, value) {

    var media = mediaObjects[id];

    if (media) {
        switch(msgType) {
            case UCTencentTaiPlugin.RECORD_STATE :
                if (media.statusCallback) {
                    media.statusCallback(value);
                }
                break;
            default :
                if (console.error) {
                    console.error("Unhandled UCTencentTaiPlugin.onStatus :: " + msgType);
                }
                break;
        }
    } else if (console.error) {
        console.error("Received UCTencentTaiPlugin.onStatus callback for unknown media :: " + id);
    }

};


module.exports = UCTencentTaiPlugin;

function onMessageFromNative(msg) {
    if (msg.action == 'status') {
        UCTencentTaiPlugin.onStatus(msg.status.id, msg.status.msgType, msg.status.value);
    } else {
        throw new Error('Unknown media action' + msg.action);
    }
}

if (cordova.platformId === 'android' || cordova.platformId === 'amazon-fireos' || cordova.platformId === 'windowsphone') {

    var channel = require('cordova/channel');

    channel.createSticky('onUCTencentTaiPluginReady');
    channel.waitForInitialization('onUCTencentTaiPluginReady');

    channel.onCordovaReady.subscribe(function() {
        exec(onMessageFromNative, undefined, 'UCTencentTaiPlugin', 'messageChannel', []);
        channel.initializationComplete('onUCTencentTaiPluginReady');
    });
}


});
